/////////////////////////////////////////////////////////////////////////////
// Name:        SVGCanvasAgg.h
// Purpose:     Ag render
// Author:      Alex Thuering
// Created:     2005/05/04
// RCS-ID:      $Id: SVGCanvasAgg.h,v 1.5 2005/11/17 17:53:28 ntalex Exp $
// Copyright:   (c) 2005 Alex Thuering
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

#ifndef WX_SVG_CANVAS_AGG_H
#define WX_SVG_CANVAS_AGG_H

#include "SVGCanvas.h"
class wxSVGCanvasPathAgg;

#include <agg2/agg_pixfmt_rgb.h>
#include <agg2/agg_rendering_buffer.h>
#include <agg2/agg_renderer_scanline.h>

typedef agg::rendering_buffer RenderingBuffer;
typedef agg::pixfmt_rgb24 PixFmt;
typedef agg::renderer_base<PixFmt> RendererBase;
typedef agg::renderer_scanline_aa_solid<RendererBase> RendererSolid;

class wxSVGCanvasAgg: public wxSVGCanvas
{
  public:
	wxSVGCanvasAgg();
	~wxSVGCanvasAgg();
	
	void Init(int width, int height);
    int GetWidth() { return m_image.GetWidth(); }
    int GetHeight() { return m_image.GetHeight(); }
    wxImage GetImage();
	void Clear(wxRGBColor color = wxRGBColor(0xFF,0xFF,0xFF));
	
	wxSVGCanvasPath* CreateCanvasPath();
	wxSVGCanvasItem* CreateItem(wxSVGTextElement* element,
	  wxCSSStyleDeclaration* style = NULL);
	void DrawItem(wxSVGCanvasItem& item,
	  wxSVGMatrix& matrix, wxCSSStyleDeclaration& style);
  
  protected:
    wxImage m_image;
	RenderingBuffer* m_rbuf;
	PixFmt* m_pixf;
	RendererBase* m_rendererBase;
	RendererSolid* m_rendererSolid;
	void DrawCanvasPath(wxSVGCanvasPathAgg& canvasPath,
      wxSVGMatrix& matrix, wxCSSStyleDeclaration& style);
    void DrawCanvasImage(wxSVGCanvasImage& canvasImage,
      wxSVGMatrix& matrix, wxCSSStyleDeclaration& style);
};

#endif // WX_SVG_CANVAS_AGG_H
