//////////////////////////////////////////////////////////////////////////////
// Name:        SVGCanvasPathAgg.cpp
// Purpose:     Agg canvas path
// Author:      Alex Thuering
// Created:     2005/05/20
// RCS-ID:      $Id: SVGCanvasPathAgg.cpp,v 1.2 2005/06/05 19:07:26 ntalex Exp $
// Copyright:   (c) 2005 Alex Thuering
// Licence:     wxWindows licence
//////////////////////////////////////////////////////////////////////////////

#include "SVGCanvasPathAgg.h"
#include <wx/log.h>

wxSVGCanvasPathAgg::wxSVGCanvasPathAgg():
  m_curved(m_storage),
  m_curved_stroked(m_curved),
  m_curved_stroked_trans(m_curved_stroked, m_transform),
  m_curved_trans(m_curved, m_transform),
  m_curved_trans_contour(m_curved_trans)
{
  m_curved_trans_contour.auto_detect_orientation(false);
  m_curved_trans_contour.width(0);
  m_storage.start_new_path();
}

wxSVGCanvasPathAgg::wxSVGCanvasPathAgg(const wxSVGCanvasPathAgg& path):
  m_curved(m_storage),
  m_curved_stroked(m_curved),
  m_curved_stroked_trans(m_curved_stroked, m_transform),
  m_curved_trans(m_curved, m_transform),
  m_curved_trans_contour(m_curved_trans)
{
  m_curved_trans_contour.auto_detect_orientation(false);
  m_curved_trans_contour.width(0);
  m_storage.start_new_path();
  //m_storage.add_path(path.m_storage);
}

wxSVGRect wxSVGCanvasPathAgg::GetBBox()
{
  double x1, y1, x2, y2;
  bounding_rect(m_curved, *this, 0, 1, &x1, &y1, &x2, &y2);
  return wxSVGRect(x1, y1, x2-x1, y2-y1);
}

void wxSVGCanvasPathAgg::MoveToImpl(double x, double y)
{
  m_storage.move_to(x, y);
}

void wxSVGCanvasPathAgg::LineToImpl(double x, double y)
{
  m_storage.line_to(x, y);
}

void wxSVGCanvasPathAgg::CurveToCubicImpl(double x1, double y1,
 double x2, double y2, double x, double y)
{
  m_storage.curve4(x1, y1, x2, y2, x, y);
}

bool wxSVGCanvasPathAgg::ClosePathImpl()
{
  m_storage.end_poly(path_flags_close);
  return true;
}
