//////////////////////////////////////////////////////////////////////////////
// Name:        SVGCanvasLibart.h
// Purpose:     Libart render
// Author:      Alex Thuering
// Created:     2005/05/06
// RCS-ID:      $Id: SVGCanvasLibart.h,v 1.8 2005/11/17 17:53:28 ntalex Exp $
// Copyright:   (c) 2005 Alex Thuering
// Licence:     wxWindows licence
//////////////////////////////////////////////////////////////////////////////

#ifndef WX_SVG_CANVAS_LIBART_H
#define WX_SVG_CANVAS_LIBART_H

#include "SVGCanvas.h"

#ifndef LIBART_H
class ArtSVP;
#endif

class wxSVGCanvasPathLibart;
class wxSVGCanvasTextFreetype;

class wxSVGCanvasLibart: public wxSVGCanvas
{
  public:
	wxSVGCanvasLibart() { }
	
	void Init(int width, int height);
    int GetWidth() { return m_image.GetWidth(); }
    int GetHeight() { return m_image.GetHeight(); }
    wxImage GetImage();
	void Clear(wxRGBColor color = wxRGBColor(0xFF,0xFF,0xFF));
	
	wxSVGCanvasPath* CreateCanvasPath();
	wxSVGCanvasItem* CreateItem(wxSVGTextElement* element,
	  wxCSSStyleDeclaration* style = NULL);
	
	void DrawItem(wxSVGCanvasItem& item,
	  wxSVGMatrix& matrix, wxCSSStyleDeclaration& style);
  
  protected:
	wxImage m_image;
	void DrawCanvasPath(wxSVGCanvasPathLibart& canvasPath,
	  wxSVGMatrix& matrix, wxCSSStyleDeclaration& style);
	void DrawSVP(ArtSVP* svp, const wxRGBColor& color, double opacity);
	void DrawCanvasImage(wxSVGCanvasImage& canvasImage,
      wxSVGMatrix& matrix, wxCSSStyleDeclaration& style);
};

#endif // WX_SVG_CANVAS_LIBART_H
